<?php
/**
* @author Roket007, http://roket.kiev.ua
* @email roket007@yandex.ru
* @version $Id: com_roketqa.xml 52 2012-08-25 22:35:11Z roket007
* @package Xmap
* @license GNU/GPL
* @description Plugin for Roket Question and Answer component
*/

defined('_JEXEC') or defined ('_VALID_MOS') or die ('Restricted Access');

class xmap_com_roketqa {

	function prepareMenuItem(&$node,&$params)
    {
        $link_query = parse_url($node->link);
        parse_str(html_entity_decode($link_query['query']), $link_vars);
        $view = xmap_com_roketqa::getParam($link_vars, 'view', '');
        if ($view == "list") {
            $node->uid = 'com_roketqa';
            $node->expandible = true;
        }
    }
	
	function getTree( &$xmap, &$parent, &$params ) {
		
		$link_query = parse_url($parent->link);
        parse_str(html_entity_decode($link_query['query']), $link_vars);
		$params['Itemid'] = intval(xmap_com_virtuemart::getParam($link_vars, 'Itemid', $parent->id));
		$database = &JFactory::getDBO();
		$urlBase = JURI::base();
		$priority = !empty($params['q_priority'])? $params['q_priority'] : $parent->priority;
		$changefreq = !empty($params['q_changefreq'])? $params['q_changefreq'] : $parent->changefreq;
		if ( $priority  == '-1' )$priority = $parent->priority;
		if ( $changefreq  == '-1' )$changefreq = $parent->changefreq;
		$params['q_priority'] = $priority;
		$params['q_changefreq'] = $changefreq;
		$query = "SELECT a.title_q title,a.id_q id,MAX(UNIX_TIMESTAMP(b.date_c_q_a)) date FROM #__roket_question a LEFT JOIN #__roket_answer b ON a.id_q = b.id_q_a WHERE a.published = 1 GROUP BY a.id_q";
		$database->setQuery($query);
		$rows = $database->loadObjectList();
		$xmap->changeLevel(1);
		foreach($rows as $row)
		{
			$node = new stdclass;
			$node->id = $params['Itemid'];
			$node->name = $row->title;
			$node->uid = $parent->uid . 'c' . $row->id;
			$node->modified = (int)$row->date;
			$node->priority   = $params['q_priority'];		
			$node->changefreq = $params['q_changefreq'];
			$node->link = 'index.php?option=com_roketqa&amp;view=deteils&amp;qid='.$row->id;
			$node->expandible = true;
			$xmap->printNode($node);
		}
		$xmap->changeLevel(-1);
		return true;
	}
	
	function getParam($arr, $name, $def)
    {
        return JArrayHelper::getValue($arr, $name, $def, '');
    }

	
}

